manjaro-tools/bin/mkiso.in

337 lines
12 KiB
Text
Raw Normal View History

2014-12-04 19:19:54 +01:00
#!/bin/bash
2014-12-04 19:20:28 +01:00
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
version=@version@
2014-12-04 19:19:54 +01:00
2014-12-04 22:54:23 +01:00
[[ -r @libdir@/util-msg.sh ]] && source @libdir@/util-msg.sh
[[ -r @libdir@/util.sh ]] && source @libdir@/util.sh
2014-12-04 19:19:54 +01:00
PKGLIST=""
QUIET="y"
FORCE="n"
PACCONFIG="/etc/pacman.conf"
export LABEL="MANJARO_$(date +%Y%m)"
PUBLISHER="Manjaro Linux <http://www.manjaro.org>"
APPLICATION="Manjaro Linux Live/Rescue CD"
COMPRESSION="xz"
CREATE_DEFAULT="n"
INSTALL_DIR="manjaro"
IMAGE_FOLDER="root-image"
APPNAME=$(basename "${0}")
# usage: usage <exitvalue>
usage ()
{
echo "usage ${APPNAME} [options] command <command options>"
echo " general options:"
echo " -f Force overwrite of working files/squashfs image/bootable image"
echo " -p PACKAGE(S) Additional package(s) to install, can be used multiple times"
echo " -C <file> Config file for pacman. Default $PACCONFIG"
echo " -L <label> Set a label for the disk"
echo " -P <publisher> Set a publisher for the disk"
echo " -A <application> Set an application name for the disk"
echo " -a <arch> Set an architecture for the disk (example: i686)"
echo " -c <compressor> Set SquashFS compression type: gzip, xz or lzo. Default $COMPRESSION"
echo " NOTES:"
echo " xz: needs Linux >= 2.6.35 - you can add '-x' for better compression"
echo " lzo: needs Linux >= 2.6.36"
echo " -D <install_dir> Set an install_dir. All files will by located here on ISO (except for isolinux)"
echo " Default $INSTALL_DIR"
echo " NOTE: Max 8 characters, use only [a-z0-9]"
echo " -i <image_folder> Set an image_folder for installing selected packages to."
echo " Default $IMAGE_FOLDER"
echo " -d Create default user directory /home/manjaro"
echo " -v Enable verbose output"
echo " -h This message"
echo " commands:"
echo " create <dir>"
echo " create a base directory layout to work with"
echo " includes all specified packages"
echo " iso <dir> <image name>"
echo " build an iso image from the working dir"
exit $1
}
2014-12-04 22:54:23 +01:00
orig_argv=("$@")
2014-12-04 19:19:54 +01:00
while getopts 'p:C:L:P:A:a:c:D:i:dfvhx' arg; do
case "${arg}" in
p) PKGLIST="${PKGLIST} ${OPTARG}" ;;
C) PACCONFIG="${OPTARG}" ;;
L) LABEL="${OPTARG}" ;;
P) PUBLISHER="${OPTARG}" ;;
A) APPLICATION="${OPTARG}" ;;
a) ARCH="${OPTARG}" ;;
c) COMPRESSION="${OPTARG}" ;;
D) INSTALL_DIR="${OPTARG}" ;;
i) IMAGE_FOLDER="${OPTARG}" ;;
d) CREATE_DEFAULT="y" ;;
f) FORCE="y" ;;
x) HIGHCOMP=" -b 256K -Xbcj x86" ;;
v) QUIET="n" ;;
h|?) usage 0 ;;
*) echo "invalid argument '${arg}'"; usage 1 ;;
esac
done
if [ "${COMPRESSION}" != "xz" ]; then
HIGHCOMP=""
fi
#trim spaces
PKGLIST="$(echo $PKGLIST)"
shift $(($OPTIND - 1))
2014-12-04 22:54:23 +01:00
check_root "$0" "${orig_argv[@]}"
2014-12-04 19:19:54 +01:00
if [ ! -f "$PACCONFIG" ]; then
2014-12-04 22:54:23 +01:00
error "pacman config file '$PACCONFIG' does not exist"
2014-12-04 19:19:54 +01:00
fi
command_name="${1}"
work_dir=""
imgname=""
case "${command_name}" in
create) work_dir="${2}"; imgname="none" ;;
iso) work_dir="${2}"; imgname="${3}" ;;
2014-12-04 23:10:11 +01:00
*) error "Invalid command name ${command_name}" && usage 1 ;;
2014-12-04 19:19:54 +01:00
esac
if [ -z "${ARCH}" ] ; then
2014-12-04 22:54:23 +01:00
error "You need to specify an architecture:\ni686\nx86_64" && usage 1
2014-12-04 19:19:54 +01:00
fi
2014-12-04 22:54:23 +01:00
[ "x${imgname}" = "x" ] && msg "Image name must be specified" && usage 1
[ "x${work_dir}" = "x" ] && msg "Please specify a working directory" && usage 1
2014-12-04 19:19:54 +01:00
2014-12-04 23:10:11 +01:00
msg "${APPNAME} : Configuration Settings"
msg2 "working directory: ${work_dir}"
msg2 "image name: ${imgname}"
2014-12-04 19:19:54 +01:00
# usage: _pacman <packages>...
_pacman ()
{
local ret
mkdir -p "${work_dir}/${IMAGE_FOLDER}/var/lib/pacman"
if [ "${QUIET}" = "y" ]; then
2014-12-10 19:06:52 +01:00
# eventually replace it with mkchroot to get better mout handling
2014-12-07 06:36:46 +01:00
setarch ${ARCH} basestrap -GMcd "${work_dir}/${IMAGE_FOLDER}" --config "$PACCONFIG" $* &> /dev/null
2014-12-10 19:06:52 +01:00
# make the chroot compatible to use chroot-run
echo "$version" > "${work_dir}/${IMAGE_FOLDER}/.manjaro-tools"
2014-12-04 19:19:54 +01:00
ret=$?
else
2014-12-10 19:06:52 +01:00
# eventually replace it with mkchroot to get better mout handling
2014-12-07 06:36:46 +01:00
setarch ${ARCH} basestrap -GMcd "${work_dir}/${IMAGE_FOLDER}" --config "$PACCONFIG" $*
2014-12-10 19:06:52 +01:00
# make the chroot compatible to use chroot-run
echo "$version" > "${work_dir}/${IMAGE_FOLDER}/.manjaro-tools"
2014-12-04 19:19:54 +01:00
ret=$?
fi
if [ -e "${work_dir}/root-image/etc/locale.gen" ]; then
cp ${work_dir}/root-image/etc/locale.gen ${work_dir}/root-image/etc/locale.gen.bak
fi
# Cleanup
find "${work_dir}" -name *.pacnew -name *.pacsave -name *.pacorig -delete
if [ $ret -ne 0 ]; then
exit 1
fi
}
2014-12-10 19:06:52 +01:00
_mkchroot ()
{
local ret
#mkdir -p "${work_dir}/${IMAGE_FOLDER}/var/lib/pacman"
if [ "${QUIET}" = "y" ]; then
setarch "${ARCH}" \
mkchroot -C "${PACCONFIG}" "${work_dir}/${IMAGE_FOLDER}" "$@" &> /dev/null
ret=$?
else
setarch "${ARCH}" \
mkchroot -C "${PACCONFIG}" "${work_dir}/${IMAGE_FOLDER}" "$@"
ret=$?
fi
if [ -e "${work_dir}/root-image/etc/locale.gen" ]; then
cp ${work_dir}/root-image/etc/locale.gen ${work_dir}/root-image/etc/locale.gen.bak
fi
# Cleanup
find "${work_dir}" -name *.pacnew -name *.pacsave -name *.pacorig -delete
if [ $ret -ne 0 ]; then
exit 1
fi
}
2014-12-04 19:19:54 +01:00
command_create () {
2014-12-04 22:54:23 +01:00
msg "Creating working directory: ${work_dir}"
2014-12-04 19:19:54 +01:00
mkdir -p "${work_dir}/iso/${INSTALL_DIR}/${ARCH}"
mkdir -p "${work_dir}/${IMAGE_FOLDER}/"
if [ ! -z "${PKGLIST}" ]; then
2014-12-04 22:54:23 +01:00
msg2 "Installing packages to '${work_dir}/${IMAGE_FOLDER}/'"
2014-12-10 19:06:52 +01:00
_mkchroot "${PKGLIST}"
2014-12-04 19:19:54 +01:00
2014-12-04 22:54:23 +01:00
msg2 "Cleaning up what we can"
2014-12-04 19:19:54 +01:00
if [ -d "${work_dir}/${IMAGE_FOLDER}/boot/" ]; then
# remove the initcpio images that were generated for the host system
find "${work_dir}/${IMAGE_FOLDER}/boot" -name '*.img' -delete
fi
if [ ${CREATE_DEFAULT} == "y" ]; then
if [ -d "${work_dir}/${IMAGE_FOLDER}/home/" ]; then
2014-12-04 22:54:23 +01:00
msg2 "Creating default home directory"
2014-12-10 19:06:52 +01:00
install -d -o1000 -g100 -m0755 "${work_dir}/${IMAGE_FOLDER}/home/${username}"
2014-12-04 19:19:54 +01:00
fi
fi
# Delete pacman database sync cache files (*.tar.gz)
find "${work_dir}/${IMAGE_FOLDER}/var/lib/pacman" -maxdepth 1 -type f -delete >/dev/null
# Delete pacman database sync cache
find "${work_dir}/${IMAGE_FOLDER}/var/lib/pacman/sync" -delete >/dev/null
# Delete pacman package cache
find "${work_dir}/${IMAGE_FOLDER}/var/cache/pacman/pkg" -type f -delete >/dev/null
# Delete all log files, keeps empty dirs.
find "${work_dir}/${IMAGE_FOLDER}/var/log" -type f -delete >/dev/null
# Delete all temporary files and dirs
find "${work_dir}/${IMAGE_FOLDER}/var/tmp" -mindepth 1 -delete >/dev/null
# Delete all temporary files and dirs
find "${work_dir}/${IMAGE_FOLDER}/tmp" -mindepth 1 -delete >/dev/null
fi
}
# _mksquash dirname
_mksquash () {
if [ ! -d "$1" ]; then
2014-12-04 22:54:23 +01:00
error "$1 is not a directory"
2014-12-04 19:19:54 +01:00
return 1
fi
sqimg="${work_dir}/iso/${INSTALL_DIR}/${ARCH}/$(basename ${1}).sqfs"
2014-12-04 22:54:23 +01:00
msg "Generating SquashFS image for '${1}'"
2014-12-04 19:19:54 +01:00
if [ -e "${sqimg}" ]; then
dirhaschanged=$(find ${1} -newer ${sqimg})
2014-12-04 22:54:23 +01:00
msg2 "Possible changes for ${1}..." >> /tmp/mkiso.debug
msg2 "${dirhaschanged}" >> /tmp/mkiso.debug
2014-12-04 19:19:54 +01:00
if [ ! -z "${dirhaschanged}" ]; then
2014-12-04 22:54:23 +01:00
msg2 "SquashFS image '${sqimg}' is not up to date, rebuilding..."
2014-12-04 19:19:54 +01:00
rm "${sqimg}"
else
2014-12-04 22:54:23 +01:00
msg2 "SquashFS image '${sqimg}' is up to date, skipping."
2014-12-04 19:19:54 +01:00
return
fi
fi
2014-12-04 22:54:23 +01:00
msg2 "Creating SquashFS image. This may take some time..."
2014-12-04 19:19:54 +01:00
start=$(date +%s)
if [ "${QUIET}" = "y" ]; then
mksquashfs "${1}" "${sqimg}" -noappend -comp "${COMPRESSION}" ${HIGHCOMP} >/dev/null
else
mksquashfs "${1}" "${sqimg}" -noappend -comp "${COMPRESSION}" ${HIGHCOMP}
fi
minutes=$(echo $start $(date +%s) | awk '{ printf "%0.2f",($2-$1)/60 }')
2014-12-04 22:54:23 +01:00
msg "Image creation done in $minutes minutes."
2014-12-04 19:19:54 +01:00
}
_imgcommon () {
for d in $(find "${work_dir}" -maxdepth 1 -type d -name '[^.]*'); do
if [ "$d" != "${work_dir}/iso" -a \
"$(basename "$d")" != "iso" -a \
"$(basename "$d")" != "efiboot" -a \
"$d" != "${work_dir}" ]; then
_mksquash "$d"
fi
done
2014-12-04 22:54:23 +01:00
msg "Making bootable image"
2014-12-04 19:19:54 +01:00
# Sanity checks
if [ ! -d "${work_dir}/iso" ]; then
2014-12-04 22:54:23 +01:00
error "${work_dir}/iso doesn't exist. What did you do?!"
2014-12-04 19:19:54 +01:00
fi
if [ ! -f "${work_dir}/iso/${INSTALL_DIR}/isomounts" ]; then
2014-12-04 22:54:23 +01:00
error "The isomounts file doesn't exist. This image won't do anything"
abort "Protecting you from yourself and erroring out here..."
2014-12-04 19:19:54 +01:00
fi
if [ -e "${imgname}" ]; then
if [ "${FORCE}" = "y" ]; then
2014-12-04 22:54:23 +01:00
msg2 "Removing existing bootable image..."
2014-12-04 19:19:54 +01:00
rm -rf "${imgname}"
else
2014-12-04 22:54:23 +01:00
error "Image ${imgname} already exists, aborting."
2014-12-04 19:19:54 +01:00
fi
fi
if ! sed "s|%MANJAROISO_LABEL%|${LABEL}|g;
s|%INSTALL_DIR%|${INSTALL_DIR}|g;
s|%ARCH%|${ARCH}|g" -i ${work_dir}/iso/isolinux/*.cfg; then
2014-12-04 22:54:23 +01:00
abort "${work_dir}/iso/isolinux/isolinux.cfg, doesn't exist, aborting."
2014-12-04 19:19:54 +01:00
fi
if [ ! -f "${work_dir}/iso/isolinux/isolinux.bin" ]; then
2014-12-04 22:54:23 +01:00
abort "${work_dir}/iso/isolinux/isolinux.bin, doesn't exist, aborting."
2014-12-04 19:19:54 +01:00
fi
if [ ! -f "${work_dir}/iso/isolinux/isohdpfx.bin" ]; then
2014-12-04 22:54:23 +01:00
abort "${work_dir}/iso/isolinux/isohdpfx.bin, doesn't exist, aborting."
2014-12-04 19:19:54 +01:00
fi
}
command_iso () {
_imgcommon
_iso_efi_boot_args=""
# If exists, add an EFI "El Torito" boot image (FAT filesystem) to ISO-9660 image.
if [ -f "${work_dir}/iso/EFI/miso/manjaro.img" ]; then
_iso_efi_boot_args="-eltorito-alt-boot -e EFI/miso/manjaro.img \
-isohybrid-gpt-basdat -no-emul-boot"
fi
2014-12-04 22:54:23 +01:00
msg "Creating ISO image..."
2014-12-04 19:19:54 +01:00
## Generate the BIOS+ISOHYBRID CD image using xorriso (extra/libisoburn package) in mkisofs emulation mode
_qflag=""
if [ ${QUIET} == "y" ]; then
_qflag="-quiet"
fi
xorriso -as mkisofs ${_qflag} \
-iso-level 3 -rock -joliet \
-max-iso9660-filenames -omit-period \
-omit-version-number \
-relaxed-filenames -allow-lowercase \
-volid "${LABEL}" \
-appid "${APPLICATION}" \
-publisher "${PUBLISHER}" \
-preparer "prepared by mkmiso" \
-eltorito-boot isolinux/isolinux.bin \
-eltorito-catalog isolinux/boot.cat \
-no-emul-boot -boot-load-size 4 -boot-info-table \
-isohybrid-mbr "${work_dir}/iso/isolinux/isohdpfx.bin" \
${_iso_efi_boot_args} \
-output "${imgname}" \
"${work_dir}/iso/"
}
# Go through the main commands in order. If 'all' was specified, then we want
# to do everything. Start with 'install'.
if [ "${command_name}" = "create" ]; then
command_create
fi
if [ "${command_name}" = "iso" ]; then
command_iso
fi